<template>
  <!-- Loading error -->
  <rui-alert v-if="loadError"
             icon="warning"
             variant="danger"
             class="-md"
             centered>
    {{ $t('js.generic.load_error') }}

    <div class="-mtl"><rui-button size="large" variant="destructive" :caption="$t('js.generic.retry')" @click="loadData" /></div>
  </rui-alert>

  <!-- Map not found  -->
  <rui-alert v-else-if="mapError" variant="warning" class="-md" centered>
    {{ $t('js.layouts.garden.map_not_found') }}
    <div class="-mtd">
      <rui-button :to="{name: 'maps'}" :caption="$t('js.garden.show_maps_list')" size="large" variant="helping" />
    </div>
  </rui-alert>

  <!-- Map found -->
  <div v-else>
    <rui-tabs no-text-on-small>
      <rui-button :to="{ name: 'map', params: $route.params }" icon="leaf">
        {{ $t('js.layouts.garden.toolbar.map') }}
      </rui-button>

      <rui-button :to="{ name: 'tasks', params: $route.params}" icon="checks">
        {{ $t('js.layouts.garden.toolbar.todo') }}
      </rui-button>

      <rui-button :to="{ name: 'coordination', params: $route.params}" icon="coordination">
        {{ $t('js.layouts.garden.toolbar.coordination') }}
      </rui-button>

      <rui-button :to="{ name: 'inventory', params: $route.params}" icon="table">
        {{ $t('js.layouts.garden.toolbar.resource_overview') }}
      </rui-button>

      <rui-button :to="{ name: 'harvests', params: $route.params}" icon="harvest">
        {{ $t('js.layouts.garden.toolbar.harvests') }}
      </rui-button>

      <rui-tab-separator />

      <rui-button :to="{ name: 'timeline', params: $route.params}" icon="observations">
        {{ $t('js.layouts.garden.toolbar.timeline') }}
      </rui-button>

      <rui-tab-separator spring />

      <rui-toolbar>
        <rui-button :to="{ name: 'library'}" icon="library">
          {{ $t('js.layouts.garden.toolbar.library') }}
        </rui-button>

        <rui-toolbar-separator />

        <rui-dropdown :caption="$t('js.generic.more')" right no-caption>
          <rui-menu-item :to="{ name: 'activities', params: $route.params}" icon="activity">
            {{ $t('js.layouts.garden.toolbar.activities') }}
          </rui-menu-item>

          <rui-menu-item :to="{ name: 'team', params: $route.params}" icon="users">
            {{ $t('js.layouts.garden.toolbar.team') }}
          </rui-menu-item>

          <rui-menu-item :to="{ name: 'soilAnalysis'}" icon="soil-analysis">
            {{ $t('js.layouts.garden.toolbar.soil_analysis') }}
          </rui-menu-item>
        </rui-dropdown>
      </rui-toolbar>
    </rui-tabs>

    <router-view v-if="ready" />
    <rui-loading v-else
                 :text="$t('js.garden.loading_map_data')"
                 fill
                 relative
                 class="gpa-garden" />
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiDropdown from '@experiments-labs/rise_ui/src/components/Dropdown/Dropdown.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'
import RuiTabs from '@experiments-labs/rise_ui/src/components/Tabs/Tabs.vue'
import RuiTabSeparator from '@experiments-labs/rise_ui/src/components/Tabs/TabSeparator.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import RuiToolbarSeparator from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSeparator.vue'

export default {
  name: 'GardenViewsLayout',
  components: {
    RuiLoading,
    RuiMenuItem,
    RuiDropdown,
    RuiToolbarSeparator,
    RuiToolbar,
    RuiTabSeparator,
    RuiTabs,
    RuiButton,
    RuiAlert,
  },
  data () {
    return {
      ready: false,
      mapError: false,
      loadError: false,
    }
  },
  methods: {
    loadData () {
      this.ready = false
      this.loadError = false
      Promise.all([
        this.$store.dispatch('resetMapData'),
        this.$store.dispatch('loadTaskNames', this.$route.params.mapId),
        this.$store.dispatch('loadElements', this.$route.params.mapId),
        this.$store.dispatch('loadLayers', this.$route.params.mapId),
        this.$store.dispatch('loadPatches', this.$route.params.mapId),
        this.$store.dispatch('loadPaths', this.$route.params.mapId),
        this.$store.dispatch('loadTeamMates', this.$route.params.mapId),
      ])
        .then(() => {
          if (!this.$store.getters.map(parseInt(this.$route.params.mapId, 10))) {
            this.mapError = true
          } else {
            this.visibleLayers = this.$store.getters.layers.map(l => l.id)
            this.ready = true
          }
        })
        .catch(() => { this.loadError = true })
    },
  },
  created () {
    this.loadData()
    this.$store.dispatch('setCurrentMap', parseInt(this.$route.params.mapId, 10))
  },
}
</script>
